spm-agent-nodejs
================
[![bitHound Score](https://www.bithound.io/github/sematext/spm-agent-nodejs/badges/score.svg)](https://www.bithound.io/github/sematext/spm-agent-nodejs/) [![bitHound Code](https://www.bithound.io/github/sematext/spm-agent-nodejs/badges/code.svg)](https://www.bithound.io/github/sematext/spm-agent-nodejs) ![build status](https://api.travis-ci.org/sematext/spm-agent-nodejs.svg)

![npm-stats](https://nodei.co/npm/spm-agent-nodejs.png?downloads=true&downloadRank=true)

This is the [Node.js monitoring](http://sematext.com/spm/integrations/nodejs-monitoring.html) agent for [SPM performance monitoring](http://sematext.com/spm) from Sematext.

The following information is collected and transmitted to SPM (Cloud or On-Premises version):

- OS Metrics (CPU / Mem)
- Process Memory
- EventLoop stats
- Garbage Collector stats
- Web server stats (requests, error rate, response times etc.)
  Working for all web servers frameworks that use Node.js http/https module including 
  - "connect" based frameworks
  - Express.js, 
  - Sails.js
  - Hapi.js
  - Restify
  - and others ...

The module is able to run in cluster mode (master/worker). 

# Status

Supported Node-Versions: Node >= 0.10, 0.12, 4.x, 5.x 

Please check our [blog](http://blog.sematext.com/tag/node.js/) for more information or
contact us at [npmjs@sematext.com](mailto:npmjs@sematext.com).

# Installation

```

    npm install spm-agent-nodejs

```

Get a free account and create a Node.js API token at [sematext.com/spm](https://apps.sematext.com/users-web/register.do)

# Configuration

We use https://www.npmjs.com/package/rc for configuration. This means config parameters can be passed via several config
locations commandline args or ENV variables. We recommend to use a file in current directory in INI or JSON format called ".spmagentrc".
This file can be generated by providing setting and environment variable and calling a helper script:

        export SPM_TOKEN=YOUR-SPM-TOKEN
        node ./node_modules/spm-agent-nodejs/bin/spmconfig.js

The command above generates following default configuration file:

        # Directory for buffered metrics
        dbDir = ./spmdb

        # Application Token for SPM
        [tokens]
          spm = YOUR-SPM-TOKEN

        [logger]
          # log file directory default is ./spmlogs
          dir = ./spmlogs
          # silent = true means no creation of log files
          silent = false
          # log level for output - debug, info, error, defaults to error to be quiet
          level = error


The only required setting is the SPM Application Token, this could be set via config file ".spmagentrc" or environment variable:

    export spmagent_tokens__spm=YOUR-SPM-APP-TOKEN

Please note the use of double "_" for nested properties


# Usage

## Node Version 0.10 and 0.12
Add this line at the begin of your source code / main script / app.js

```js
    var spmAgent = require ('spm-agent-nodejs')
```

## Node Version > 4.x 
There is an alternative using latest 4.x and 5.x releases. It supports a command line option "-r" to preload node modules before the actual application is started. In this case the original source code needs no modification:

```sh
  node -r './spm-agent-nodejs' yourApp.js
```

# Results

- _[Top Node.js Metrics to Watch](http://blog.sematext.com/2015/12/02/top-nodejs-metrics-to-watch/)
![SPM for Node.js screenshot](https://sematext.files.wordpress.com/2015/12/bildschirmfoto-2015-12-05-um-21-12-521.png)_

# Troubleshooting

Please visit our [WIKI](https://sematext.atlassian.net/wiki/display/PUBSPM/SPM+for+Node.js) for more information

# Other SPM related packages

Please check out [spm-metrics-js](https://www.npmjs.com/package/spm-metrics-js) to monitor any custom metric in your application.

[sematext-agent-docker](https://registry.hub.docker.com/u/sematext/sematext-agent-docker/), aka [Sematext Agent for Docker](http://blog.sematext.com/2015/06/09/docker-monitoring-support/)

# LICENCE

Apache 2 - see [LICENSE](https://github.com/sematext/spm-agent-nodejs/blob/master/LICENSE) file.

